.loading {
  position: relative;

  &:after {
    width: 16px;
    height: 16px;
    border: solid 1px #fff;
    border-top-color: transparent !important;
    display: inline-block;
    position: absolute;
    top: 50%;
    left: 10px;
    margin-top: -8px;
    content: '';
    border-radius: 50%;
    animation: spin 1s infinite linear;
  }

  &.loading-right:after {
    left: auto;
    right: 10px;
  }

  &.loading-center:after {
    left: 50%;
    right: auto;
    margin-left: -8px;
  }

  &.loading-gray:after {
    border-color: $gray-500;
  }
  &.loading-primary:after {
    border-color: $primary;
  }
}

.beh-loading {
  position: relative;

  &:after {
    position: absolute;
    display: block;
    visibility: hidden;
    opacity: 0;
    content: "";
    top: 0;
    left: 0;
    height: 100%;
    width: 100%;
    background: rgba(255, 255, 255, 0.6);
    transition: all .2s ease;
    z-index: $z-index-beh-loading;
  }

  .beh-spinner {
    display: none;
    position: absolute;
    top: 50%;
    left: 50%;
    transform: translate(-50%, -50%);
    z-index: 302;

    svg {
      animation: beh-spinner-rotation 1.4s linear infinite;
      stroke: $primary;
      vertical-align: middle;

      .circle {
        stroke-dasharray: 187;
        stroke-dashoffset: 0;
        transform-origin: center;
        animation: beh-spinner-turn 1.4s ease-in-out infinite;
      }
    }
  }

  &-active {
    &:after {
      visibility: visible;
      opacity: 1;
    }

    > .beh-spinner {
      display: block;
    }
  }

  &-sm > .beh-spinner svg {
    width: 20px !important;
    height: 20px !important;
  }

  &.variant-white {
    &:after {
      background: rgba(0, 0, 0, 0.4);
    }

    .beh-spinner svg .circle {
      stroke: white;
    }
  }
}

@keyframes beh-spinner-rotation {
  0% {
    transform: rotate(0deg);
  }

  100% {
    transform: rotate(270deg);
  }
}

@keyframes beh-spinner-turn {
  0% {
    stroke-dashoffset: 187;
  }

  50% {
    stroke-dashoffset: 46.75;
    transform: rotate(135deg);
  }

  100% {
    stroke-dashoffset: 187;
    transform: rotate(450deg);
  }
}

@keyframes spin {
  0% {
    transform: rotate(0deg);
  }

  100% {
    transform: rotate(360deg);
  }
}
